#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "uae.h"
#include "options.h"
#include "custom.h"
#include "memory.h"
#include "blitter.h"
#include "blitfunc.h"

#ifndef USE_SHORT_BLITTABLE
blitter_func const *blitfunc_dofast[512] = {
#else
blitter_func const *blitfunc_dofast[256] = {
#endif
blitdofast_0, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_a, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_2a, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_30, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_3a, blitdofast_fill, blitdofast_3c, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_4a, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_6a, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_8a, blitdofast_fill, blitdofast_8c, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_9a, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_a8, blitdofast_fill, blitdofast_aa, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_b1, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_ca, blitdofast_fill, blitdofast_cc, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_d8, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_e2, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_ea, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_f0, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, 
blitdofast_fill, blitdofast_fill, blitdofast_fa, blitdofast_fill, blitdofast_fc, blitdofast_fill, blitdofast_fill, blitdofast_fill,
#ifndef USE_SHORT_BLITTABLE
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill, blitdofast_fill,
#endif
};

#ifndef USE_SHORT_BLITTABLE
blitter_func const *blitfunc_dofast_desc[512] = {
#else
blitter_func const *blitfunc_dofast_desc[256] = {
#endif
blitdofast_desc_0, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_a, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_2a, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_30, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_3a, blitdofast_desc_fill, blitdofast_desc_3c, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_4a, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_6a, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_8a, blitdofast_desc_fill, blitdofast_desc_8c, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_9a, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_a8, blitdofast_desc_fill, blitdofast_desc_aa, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_b1, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_ca, blitdofast_desc_fill, blitdofast_desc_cc, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_d8, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_e2, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_ea, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_f0, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, 
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fa, blitdofast_desc_fill, blitdofast_desc_fc, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
#ifndef USE_SHORT_BLITTABLE
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill, blitdofast_desc_fill,
#endif
};
